mkelem = (elemtype, classname='', attrs={}) ->
    elem = document.createElement elemtype
    elem.className = classname
    elem[attr] = value for own attr, value of attrs
    elem

# replace an input element with an addon group
create_addon = (input) ->
    group = mkelem 'div', 'input-group'
    input.parentNode.replaceChild group, input
    group.appendChild input
    addon = mkelem 'div', 'input-group-addon'
    group.appendChild addon
    addon

# focus on first input field in first form
document.querySelector('form:not(.nofocus)')?.querySelector('input')?.focus()

# add an addon to range inputs displaying the currently selected value
for e in document.querySelectorAll 'input[type=range]'
    create_addon e

    cb = -> @nextElementSibling.innerHTML = @value
    e.addEventListener 'change', cb
    e.addEventListener 'input', cb

    cb.call e

# add a calender addon to date inputs, and focus on input on addon click
for e in document.querySelectorAll 'input[type^=date]'
    addon = create_addon e
    addon.innerHTML = '<span class="glyphicon glyphicon-calendar"></span>'
    addon.addEventListener 'click', -> @previousElementSibling.focus()

# always select the whole number on a number type input to avoid backspacing
for e in document.querySelectorAll 'input[type=number]'
    e.addEventListener 'focus', -> @select()

# inline radio labels
for e in document.querySelectorAll '.radio > label > input[type=radio][data-inline]'
    group = mkelem 'label', 'radio-inline'
    group.innerHTML = e.parentNode.innerHTML
    label = e.parentNode.parentNode
    label.parentNode.replaceChild group, label

# make abbreviations clickable on mobile devices (since there is no hover)
if /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test navigator.userAgent
    for e in document.getElementsByTagName 'abbr'
        e.addEventListener 'click', -> alert @getAttribute 'title'

# allow table rows to be links through the data-href attribute
for e in document.querySelectorAll '[data-href]'
    e.addEventListener 'click', ->
        document.location = @getAttribute 'data-href'

# fix class names on select boxes with multiple="multiple"
for e in document.querySelectorAll 'select[multiple]'
    e.classList.add 'form-control'

# tag list controls on score add/edit pages
if container = document.querySelector '.tags-control'
    tag_list = container.querySelector '.tags'
    text_input = container.querySelector 'input[type=text]'
    submit_btn =  text_input.nextElementSibling.querySelector '.btn'

    generate_inputs = ->
        for e in container.querySelectorAll 'input[type=hidden]'
            e.parentNode.removeChild e

        for e in container.querySelectorAll '.tag .text'
            container.appendChild mkelem 'input', '',
                type: 'hidden', name: 'tags[]', value: e.textContent

    submit_tag = ->
        tag = text_input.value.trim()
        return if tag == ''
        text_input.value = ''

        link = tag_list.appendChild mkelem 'a', 'tag',
            href: 'javascript:void(0)'
            title: 'Click to remove tag'

        label = link.appendChild mkelem 'span', 'label label-default'
        label.innerHTML =
            '<span class="text"></span>
             <span class="glyphicon glyphicon-remove"></span>'
        label.firstElementChild.textContent = tag

        generate_inputs()
        text_input.focus()

    text_input.addEventListener 'keydown', (e) ->
        if e.keyCode == 13
            e.preventDefault()
            submit_tag()

    submit_btn.addEventListener 'click', submit_tag

    container.addEventListener 'click', (e) ->
        if e.target.classList.contains 'glyphicon-remove'
            label = e.target.parentNode
            label.parentNode.removeChild label
            generate_inputs()

# add show/hide event to collapse targets (normally handled by Bootstrap)
for e in document.querySelectorAll '[data-toggle=collapse][data-target]'
    ((target) ->
        if target
            e.addEventListener 'click', (e) ->
                e.preventDefault()
                target.classList.toggle 'in'
    )(document.querySelector e.getAttribute 'data-target')
