table = document.getElementById 'match'

if table.classList.contains 'match-editable'
    inputs = table.querySelectorAll 'input[type=number]'
    rows = table.children[1].children
    match_total = table.querySelector '.match-total'
    match_avg = table.querySelector '.match-avg'

    h = table.querySelectorAll('tbody tr').length - 1
    w = inputs.length / h
    scores = []

    sub = (row) -> rows[row].querySelector '.row-total'
    tot = (row) -> rows[row].querySelector '.total'
    num = (s) -> if s == '' or isNaN parseInt s then 0 else parseInt s
    timer = 0

    set_score = (col, row, score) ->
        if score != scores[row * w + col]
            scores[row * w + col] = score
            clearTimeout timer
            timer = setTimeout (-> render row), 50
            true
        else
            false

    render = (dirty_row) ->
        if table.classList.contains 'hide-total-scores'
            return

        subtotal = 0
        subtotal += scores[dirty_row * w + col] for col in [0...w]
        rowsub = sub dirty_row
        rowsub.innerHTML = subtotal
        rowsub.dataset.score = Math.floor(subtotal / w)

        total = if dirty_row then num tot(dirty_row - 1).innerHTML else 0
        for row in [dirty_row...h]
            total += num sub(row).innerHTML
            rowtot = tot row
            rowtot.innerHTML = total
            rowtot.dataset.score = Math.floor(total / ((row + 1) * w))

        match_total.innerHTML = total
        match_avg.innerHTML = Math.round(total / inputs.length * 10) / 10

    for input, i in inputs
        scores.push num input.value
        ((col, row) ->
            cell = input.parentNode
            cb = ->
                value = num @value
                if set_score col, row, value
                    cell.dataset.score = value
                    if value != 10
                        @nextElementSibling.value = 0
                        @parentNode.querySelector('.cross-popup')
                            .classList.remove 'enabled'
            input.addEventListener 'change', cb
            input.addEventListener 'keyup', cb
        )(i % w, Math.floor i / w)

    render 0
    table.querySelector('input[value=""]')?.focus()

    table.addEventListener 'click', (e) ->
        if e.target.classList.contains 'cross-popup'
            v = if e.target.classList.toggle 'enabled' then 1 else 0
            e.target.parentNode.previousElementSibling.value = v
            e.target.parentNode.parentNode.children[0].focus()

    # total scores toggling + persistence in local storage
    toggle_totals = document.getElementById 'toggle-total-scores'

    if 'localStorage' of window and localStorage.getItem 'hide-total-scores'
        table.classList.add 'hide-total-scores'
        toggle_totals.classList.remove 'active'

    toggle_totals.addEventListener 'click', ->
        @classList.toggle 'active'
        @blur()
        hide = table.classList.toggle 'hide-total-scores'

        if 'localStorage' of window
            if hide
                localStorage.setItem 'hide-total-scores', true
            else
                localStorage.removeItem 'hide-total-scores'
                render 0

# notes area grows automatically with each added line
if notes = document.getElementById('notes')
    cb = ->
        @style.height = 0
        @style.height = @scrollHeight + 'px'
    notes.addEventListener 'keyup', cb
    cb.call notes

# color toggling + persistence in local storage
toggle_color = document.getElementById 'toggle-colored'

if 'localStorage' of window and localStorage.getItem 'colored-scores'
    table.classList.add 'colored'
    toggle_color.classList.add 'active'

toggle_color.addEventListener 'click', ->
    @classList.toggle 'active'
    @blur()
    colored = table.classList.toggle 'colored'

    if 'localStorage' of window
        if colored
            localStorage.setItem 'colored-scores', true
        else
            localStorage.removeItem 'colored-scores'


